module Anagram
	class Finder
		def self.from_file(file_name)
			new(File.readlines(file_name))
		end

		def initialize(dictionary_words)
			@signatures = {}
			dictionary_words.each do |line|
				word = line.chomp
				signature = Finder.signature_of(word)
				(@signatures[signature] ||= []) << word
			end
		end

		def lookup(word)
			signature = Finder.signature_of(word)
			@signatures[signature]
		end

		def self.signature_of(word)
			word.unpack("c*").sort.pack("c*")
		end
	end
end

