require 'optparse'

module Anagram
	class Options
		DEFAULT_DICTIONARY = '/usr/share/dict/words'

		attr_reader :dictionary, :words_to_find

		def initialize(argv)
			@dictionary = DEFAULT_DICTIONARY
			parse(argv)
			@words_to_find = argv
		end

		private

		def parse(argv)
			OptionParser.new do |o|
				o.banner = "Usage: anagram [OPTION]... WORD..."

				o.on("-d", "--dict PATH", String, "Path to dictionary") do |d|
					@dictionary = d
				end

				o.on("-h", "--help", "Show this message") do
					puts o
					exit
				end

				begin
					argv = ["-h"] if argv.empty?
					o.parse!(argv)
				rescue OptionParser::ParseError => e
					STDERR.puts e.message, "\n", o
					exit -1
				end
			end
		end
	end
end

